/**
 * @file  divided_cmd_utility.h
 * @brief R}hT|[gUtil
 * @note  HOW TO USE
 *        1. eCmdɂď߂ DCU_check_in sC݂̎s󋵂擾
 *        2. sI ēxċAKvꍇ DCU_register_next œo^
 *        3. ׂĂ̏Iꍇ DCU_report_finish s
 *        4. s̃G[ DCU_report_err ŕ񍐂Dƒf
 *        5. fƂ DCU_abort_cmd s
 *        6. fꂽԂZbgꍇ DCU_donw_abort_flag s
 * @note  telemetry_manager ȂǂŎgĂ̂ŁCQƂ̂
 */
#ifndef DIVIDED_CMD_UTILITY_H_
#define DIVIDED_CMD_UTILITY_H_

#include "../System/ApplicationManager/app_info.h"
#include "../CmdTlm/common_tlm_cmd_packet.h"
#include "../System/TimeManager/obc_time.h"
#include <src_user/CmdTlm/command_definitions.h>

#define DCU_LOG_MAX    (16)    //!< ۑ郍O̍ő吔

#include <src_user/Settings/Applications/divided_cmd_utility_params.h>

// key  uint8_t Ȃ̂ŁCȉv
#if DCU_LOG_MAX > 255
#error "err at divided_cmd_utility"
#endif

/**
 * @enum   DCU_ACK
 * @note   uint8_t z
 * @brief  ėpԂl
 */
typedef enum
{
  DCU_ACK_OK = 0,       //!< I
  DCU_ACK_ERR,          //!< G[
} DCU_ACK;


/**
 * @enum   DCU_STATUS
 * @note   uint8_t z
 * @brief  s
 */
typedef enum
{
  DCU_STATUS_FINISHED = 0,        //!< sI or s
  DCU_STATUS_PROGRESS,            //!< s
  DCU_STATUS_ABORTED_BY_ERR,      //!< G[ɂ蒆f
  DCU_STATUS_ABORTED_BY_CMD,      //!< R}hɂ蒆f
} DCU_STATUS;


/**
 * @enum   DCU_LOG_ACK
 * @note   uint8_t z
 * @brief  O̕Ԃl
 */
typedef enum
{
  DCU_LOG_ACK_OK = 0,           //!< I
  DCU_LOG_ACK_NOT_FOUND,        //!< w胍O炸
} DCU_LOG_ACK;


/**
 * @struct DCU_ExecStatus
 * @brief  s
 */
typedef struct
{
  CMD_CODE     cmd_code;          //!< sR}h
  DCU_STATUS   status;            //!< s
  uint16_t     exec_counter;      //!< sJE^Dxڂ̎sH
  CCP_EXEC_STS last_exec_sts;     //!< ŏIs
  ObcTime      last_exec_time;    //!< ŏIs
} DCU_ExecStatus;


/**
 * @struct DividedCmdUtility
 * @brief  DividedCmdUtility  AppInfo \
 */
typedef struct
{
  DCU_ExecStatus exec_logs[DCU_LOG_MAX];        //!< sOD[exec_log_order[0]] łVDÂ͎̂̂ĂĂD
  uint8_t        exec_log_order[DCU_LOG_MAX];   //!< sÕ\[gL[D exec_logs ŐVɕבւ邽߂ɎgD
} DividedCmdUtility;

extern const DividedCmdUtility* const divided_cmd_utility;

AppInfo DCU_create_app(void);


/**
 * @brief  DCUɃ`FbNCDR}hsCŏɌĂяo֐D
 * @param[in]  cmd_code:     g CMD_CODE
 * @param[out] exec_counter: ̎s񐔂ڂH
 * @retval DCU_STATUS_FINISHED:       słD exec_counter  0 ԂD
 * @retval DCU_STATUS_PROGRESS:       2ڈȍ~̎sł
 * @retval DCU_STATUS_ABORTED_BY_ERR: G[Ă̂ŁCs𒆎~ׂi CCP_EXEC_ILLEGAL_CONTEXT Ԃׂ j
 * @retval DCU_STATUS_ABORTED_BY_CMD: sfR}hMĂ̂ŁCs𒆎~ׂi CCP_EXEC_ILLEGAL_CONTEXT Ԃׂ j
 */
DCU_STATUS DCU_check_in(CMD_CODE cmd_code, uint16_t* exec_counter);

/**
 * @brief  ̎̕so^
 * @param[in] cmd_code: g CMD_CODE
 * @param[in] param:    R}hp^
 * @param[in] len:      p^
 * @return DCU_ACK
 */
DCU_ACK DCU_register_next(CMD_CODE cmd_code, const uint8_t* param, uint16_t len);

/**
 * @brief  DCUɁCR}hsIƂ`
 * @param[in] cmd_code: g CMD_CODE
 * @param[in] last_exec_sts: R}hs
 * @return void
 */
void DCU_report_finish(CMD_CODE cmd_code, CCP_EXEC_STS last_exec_sts);

/**
 * @brief  DCUɁCrŃG[Ƃ`
 * @note   Ȍ̎s͒f
 * @param[in] cmd_code: g CMD_CODE
 * @param[in] last_exec_sts: R}hs
 * @return void
 */
void DCU_report_err(CMD_CODE cmd_code, CCP_EXEC_STS last_exec_sts);

/**
 * @brief  G[C܂̓R}hɂĒfXe[^XƂȂĂR}hCs\Ԃɖ߂
 * @param[in] cmd_code: s\Ԃɖ߂R}h CMD_CODE
 * @return void
 */
void DCU_donw_abort_flag(CMD_CODE cmd_code);

/**
 * @brief  s̕R}hO狭Iɒf
 * @note   G[ DCU_report_err gׂŁC{Iɂ͎gȂ͂
 * @note   abort ̕ÁCir̍ĊJ͕sj
 * @param[in] cmd_code: ~R}h CMD_CODE
 * @return void
 */
void DCU_abort_cmd(CMD_CODE cmd_code);

/**
 * @brief  OTāCw肵R}hO擾
 * @note   exec_log  divided_cmd_utility ̊ỸOւ̃|C^ɍւD
 * @param[in] cmd_code: TR}h
 * @param[out] exec_log: 擾ODconst|C^ŁCQƐ邽߁CNULL|C^n̂OK
 * @retval DCU_LOG_ACK_OK:        
 * @retval DCU_LOG_ACK_NOT_FOUND: 炸
 */
DCU_LOG_ACK DCU_search_and_get_log(CMD_CODE cmd_code, const DCU_ExecStatus* exec_log);

/**
 * @brief s̕R}h~
 * @note  Cw肵 Cmd sł͂ȂĂ CCP_EXEC_SUCCESS Ԃ
 */
CCP_EXEC_STS Cmd_DCU_ABORT_CMD(const CTCP* packet);

/**
 * @brief G[C܂̓R}hɂĒfXe[^XƂȂĂR}hCs\Ԃɖ߂
 * @note  Cw肵 Cmd fXe[^Xł͂ȂĂ CCP_EXEC_SUCCESS Ԃ
 */
CCP_EXEC_STS Cmd_DCU_DOWN_ABORT_FLAG(const CTCP* packet);

/**
 * @brief ONA
 */
CCP_EXEC_STS Cmd_DCU_CLEAR_LOG(const CTCP* packet);

#endif
