/**
 * @file  block_command_table.h
 * @brief BCT̒`, BCT̊֐
 */
#ifndef BLOCK_COMMAND_TABLE_H_
#define BLOCK_COMMAND_TABLE_H_

#include <src_user/Library/stdint.h>

#define BCT_CMD_MAX_LENGTH (64)  /*!< BCTɕۑpPbg̃pPbgTCY̏
                                    TCP̍ő咷͂Ȃ傫̂ŁCł͂菬ăߖ񂷂̂ʗ
                                    ̒l傫ȃR}hBCTɕۑłȂȂ邱Ƃɒӂ邱*/
#define BCT_MAX_CMD_NUM    (32)  //!< PBCɍő剽̃R}h}ł邩

#define BCT_MAX_BLOCKS    (383) //!< BCID̍ő吔
// ςCCmd_RESET_(RE)STORE_BCT* ςI
// 2019/07/19 Rgǉ
// MM_NOT_DEFINEDBCT_MAX_BLOCKS gĂ̂ŁC-1ĂD
// ǁC܂-1Kv܂ȂH


// CBCT̃TCYύX₷悤ɒ`
// R}ḧ`FbNp
#define SIZE_OF_BCT_ID_T    (2)    //!< bct_id_t ̌^TCYDCpNgȂɂ̂ŁCς

#include <src_user/Settings/CmdTlm/block_command_table_params.h>

#if SIZE_OF_BCT_ID_T == 1
typedef uint8_t bct_id_t;
#elif SIZE_OF_BCT_ID_T == 2
typedef uint16_t bct_id_t;
#elif SIZE_OF_BCT_ID_T == 4
typedef uint32_t bct_id_t;
#else
#error Illegal value for SIZE_OF_BCT_ID_T
#endif

#include "common_tlm_cmd_packet.h" // bct_id_t ̒`肠Ƃinclude

/*
Block Command Table 
BCT_MAX_BLOCKS x BCT_MAX_CMD_NUM
̃e[ułC
BCT_Pos.block ubNԍC
BCT_Pos.cmd   ̃ubNł̈ʒu
ێĂD
R}h̎f[^ۑĂ{̂

[\̒`]                        [TCY Byte]
BlockCommandTable                        7668               at 383
  BCT_Pos                               8 : 4 * 2
    block                                   2
    cmd                                     1
  BCT_Func[BCT_MAX_BLOCKS]           6128 : 4 * 4 * 383 at 383
  BCT_Table*[BCT_MAX_BLOCKS]         1532 : 4 * 383     at 383

BCT_Table                          784767               at 383
  length                                    1
  BCT_CmdData[BCT_MAX_CMD_NUM]               2048 : 64 * 32
    data[BCT_CMD_MAX_LENGTH]                        64

Sum                                792435 : 784767 + 7668
ȂC\̂̃TCÝC̃õTCY̘aɂȂƂ͌ȂƂɒӁD
̒l͖ڈłD(f[^̌̂߂ɁCpfBO邱Ƃ邽.)
*/

/**
 * @struct BCT_Pos
 * @brief  BCTł̍ƒ̈ʒu
 */
typedef struct
{
  bct_id_t block; //!< ubN̈ʒu
  uint8_t  cmd;   //!< ̃ubNłǂ̃R}hw
} BCT_Pos;

/**
 * @struct BCT_CmdData
 * @brief  Cmd ̕ۑꏊ
 * @note   TCP_MAX_LENGTH (444) ƔׂĂȂZ BCT_CMD_MAX_LENGTH (64)
 *         CTCP̒`[U[ˑȂ̂Ō uint8_t ̔zɂȂĂ (FIXME: )
 */
typedef struct
{
  uint8_t data[BCT_CMD_MAX_LENGTH];
} BCT_CmdData;

/**
 * @struct BCT_Table
 * @brief  BCT ̖{. ۂ BC  cmd mۂĂ
 */
typedef struct
{
  uint8_t     length;                   //!< cmds ɕۑĂR}h
  BCT_CmdData cmds[BCT_MAX_CMD_NUM];     //!< e cmd ۑz
} BCT_Table;

/**
 * @struct BCT_Func
 * @brief  esetter, getter 
 * @note   JĂ邪 private . getter ̓bvĂ̂łg
 *         ݂闝R͒g MRAM ȂǎOd璷Ăꏊɂ邱Ƃ邽
 */
typedef struct
{
  BCT_CmdData* (*get_bc_cmd_data_)(const BCT_Pos* pos);                           //!< cmd_data  getter
  uint8_t      (*get_bc_length_)(const bct_id_t block);                           //!< length  getter
  void         (*set_bc_cmd_data_)(const BCT_Pos* pos, const BCT_CmdData* value); //!< cmd_data  setter
  void         (*set_bc_length_)(const bct_id_t block, uint8_t length);           //!< length  setter
} BCT_Func;

/**
 * @struct BlockCommandTable
 * @brief  BCT Ŝ̍\
 */
typedef struct
{
  BCT_Pos pos;                            //!< o^Ȃǂ̍ƒ̈ʒu
  BCT_Pos pos_stored;                     /*!< OBC̏Ń|C^ςȂ悤ɂ邽߂̈ꎞޔꏊD
                                               ڍׂC2AhLg uubNR}hǉ@.mdv  */
  BCT_Table* blocks[BCT_MAX_BLOCKS];      //!< BCT̊eBCDDȏꏊŊmۂłlɃ|C^ɂĂ
  BCT_Func   func[BCT_MAX_BLOCKS];        //!< BCT֌W̊֐
} BlockCommandTable;

/**
 * @enum  BCT_ACK
 * @brief BCT ֌W̊֐̃G[Xe[^X
 * @note  uint8_t z
 */
typedef enum
{
  BCT_SUCCESS,
  BCT_INVALID_BLOCK_NO,
  BCT_INVALID_CMD_NO,
  BCT_ISORATED_CMD,
  BCT_DEFECTIVE_BLOCK,
  BCT_CMD_TOO_LONG,
  BCT_BC_FULL,
  BCT_ZERO_PERIOD,
  BCT_UNKNOWN
} BCT_ACK;

extern const BlockCommandTable* const block_command_table;

/**
 * @brief BCT ̏֐
 * @note  BCT ƏĂ邪ł BCE_init Ă΂邽 BC ֌WLۖۂ.
 */
void BCT_initialize(void);

/**
 * @brief BCT_CmdData  const pointer getter
 * @note AT[V͂Ȃ
 * @param[in] pos: const BCT_Pos*
 * @return const BCT_Pos*
 */
const BCT_CmdData* BCT_get_bc_cmd_data(const BCT_Pos* pos);

/**
 * @brief BCT  length  getter
 * @note AT[V͂ȂDLłȂ block ̏ꍇC 0 Ԃ
 * @param[in] block: BC  idx
 * @return length
 */
uint8_t BCT_get_bc_length(const bct_id_t block);

/**
 * @brief w肳ꂽ block  BCT 
 * @param[in] block: BC  idx
 * @return BCT_ACK
 */
BCT_ACK BCT_clear_block(const bct_id_t block);

/**
 * @brief pos  pos_stored ɕۑ
 * @note nǂOBCBC̃|C^ĂȂȂ悤ɂ邽߂̉C. ڍׂC2AhLg uubNR}hǉ@.mdv
 * @param  void
 * @return void
 */
void BCT_store_pos(void);

/**
 * @brief pos  pos_stored 畜
 * @param  void
 * @return void
 */
void BCT_restore_pos(void);

/**
 * @brief BCT_Pos*  validate
 * @param  pos: BCT̈ʒu
 * @return BCT_ACK
 */
BCT_ACK BCT_check_position(const BCT_Pos* pos);

/**
 * @brief BCT_Pos* 
 * @param[out] pos: ɍ pointer
 * @param[in] block: BC  idx
 * @param[in] cmd: Cmds_data ł idx
 * @return BCT_ACK
 */
BCT_ACK BCT_make_pos(BCT_Pos* pos, const bct_id_t block, const uint8_t cmd);

/**
 * @brief ۑf[^CTCPɃRs[.
 * @param[in]  pos: Rs[packeẗʒu
 * @param[out] packet: Rs[ CTCP*
 * @return BCT_ACK
 * @note  R}h͋Cɂő咷ǂݏoƂƂ.
 *        ۂ̒̓Rs[Ăwb_Ɋi[Ă.
 */
BCT_ACK BCT_load_cmd(const BCT_Pos* pos, CTCP* packet);

/**
 * @brief Cmd  block_command_table->pos ɓo^
 * @param[in] packet: o^ Cmd ̓e
 * @return BCT_ACK
 */
BCT_ACK BCT_register_cmd(const CTCP* packet);

/**
 * @brief ɓo^Ă BC  Cmd ̒gO㏑
 * @param[in] pos: ㏑ʒu
 * @param[in] packet: ㏑ packet
 * @return BCT_ACK
 */
BCT_ACK BCT_overwrite_cmd(const BCT_Pos* pos, const CTCP* packet);

/**
 * @brief BCT ̒g  BCT  COPY 
 * @param[in] dst_block Rs[ bct_id
 * @param[in] src_block Rs[ bct_id
 * @return BCT_ACK
 */
BCT_ACK BCT_copy_bct(const bct_id_t dst_block, const bct_id_t src_block);

// ȉ3 BCT ɓo^Ă Cmd 炻̓eogetter
/**
 * @brief BCT  Cmd  CMD_CODE  getter
 * @param[in] block: BC  idx
 * @param[in] cmd: Cmds_data ł idx
 * @return CMD_CODE
 * @note (block, cmd) ُlꍇ Cmd_CODE_MAX Ԃ
 */
CMD_CODE BCT_get_id(const bct_id_t block, const uint8_t cmd);

/**
 * @brief BCT  Cmd  TI  getter
 * @param[in] block: BC  idx
 * @param[in] cmd: Cmds_data ł idx
 * @return TI
 * @note (block, cmd) ُlꍇ 0 Ԃ
 */
cycle_t BCT_get_ti(const bct_id_t block, const uint8_t cmd);

/**
 * @brief BCT  Cmd  param_head  getter
 * @param[in] block: BC  idx
 * @param[in] cmd: Cmds_data ł idx
 * @return const uint8_t* |C^
 * @note (block, cmd) ُlꍇ (0, 0) ̂̂Ԃ
 */
const uint8_t* BCT_get_param_head(const bct_id_t block, const uint8_t cmd);

/**
 * @brief BCT  block ̎w|C^ & func ւ
 * @param[in] block_a: ւ BC
 * @param[in] block_b: ւ BC
 * @return BCT_ACK s
 * @note ID1:HK:SRAM, ID2:AH:MRAM  ID1:AH:MRAM, ID2:HK:SRAM o
 *       `BCT_swap_contents` Ƒgݍ킹邱ƂŔԍ - g͂̂܂܂ RAM ؂ւ邱Ƃo
 *       K `BCE_swap_address` ƋɎgp邱
 */
BCT_ACK BCT_swap_address(const bct_id_t block_a, const bct_id_t block_b);

/**
 * @brief BCT  block ̎wgւ
 * @param[in] block_a: ւ BC
 * @param[in] block_b: ւ BC
 * @return BCT_ACK s
 * @note ID1:AH:MRAM, ID2:HK:SRAM  ID1:HK:MRAM, ID2:AH:SRAM o
 *       `BCT_swap_ram` Ƒgݍ킹邱ƂŔԍ - g͂̂܂܂ RAM ؂ւ邱Ƃo
 *       K `BCE_swap_contents` ƋɎgp邱
 */
BCT_ACK BCT_swap_contents(const bct_id_t block_a, const bct_id_t block_b);

/**
 * @brief enumϊp֐
 * @param  ack: BCT_ACK
 * @return CCP_EXEC_STS
 */
CCP_EXEC_STS BCT_convert_bct_ack_to_ctcp_exec_sts(BCT_ACK ack);

CCP_EXEC_STS Cmd_BCT_CLEAR_BLOCK(const CTCP* packet);
CCP_EXEC_STS Cmd_BCT_SET_BLOCK_POSITION(const CTCP* packet);
CCP_EXEC_STS Cmd_BCT_COPY_BCT(const CTCP* packet);
CCP_EXEC_STS Cmd_BCT_OVERWRITE_CMD(const CTCP* packet);

#endif
