#pragma section REPRO
#include "command_dispatcher.h"

#include <src_user/CmdTlm/command_definitions.h>
#include "../System/TimeManager/time_manager.h"
#include "packet_handler.h"

static CDIS_EXEC_INFO CEI_init_(void);

CommandDispatcher CDIS_init(PacketList* pli)
{
  CommandDispatcher cdis;

  // R}hsB
  cdis.prev = CEI_init_();
  cdis.prev_err = CEI_init_();

  // sG[JE^0ɏB
  cdis.error_counter = 0;

  // sftO𖳌ɐݒ
  cdis.lockout = 0;

  // ُ펞sftO𖳌ɐݒB
  cdis.stop_on_error = 0;

  // ΏۂƂPacketListNAēo^B
  PL_clear_list(pli);
  cdis.pli = pli;

  return cdis;
}

static CDIS_EXEC_INFO CEI_init_(void)
{
  CDIS_EXEC_INFO cei;

  OBCT_clear(&cei.time);
  cei.time.step = 0;            // ŏdClearĂ闝R͂Ȃ񂾁DDD
  cei.code = (CMD_CODE)0;
  cei.sts = CCP_EXEC_SUCCESS;

  return cei;
}

void CDIS_dispatch_command(CommandDispatcher* cdis)
{
  // pPbgRs[pBTCY傫ߐÓIϐƂĐ錾B
  static CTCP packet_;

  if (cdis->lockout)
  {
    // sLtOĂꍇ͏ł؂B
    return;
  }

  if (PL_is_empty(cdis->pli))
  {
    // sׂR}hꍇ͏IB
    return;
  }

  if (cdis->prev.sts != CCP_EXEC_SUCCESS)
  {
    // OR}hُIꍇ͎sOɏۑB
    // sOɃRs[邱ƂŎR}hُIꍇ
    // prevprev_err2R}ḧُێłB
    cdis->prev_err = cdis->prev;
  }

  // sׂR}hpPbg擾B
  packet_ = PL_get_head(cdis->pli)->packet;

  // ŎsʂύX̂߂D
  // - MOBCzOBCɂCGS cmdTL cmd𑗐M
  // - user_packet_handler ł PH_user_cmd_router  dispatcher (AOBC_dispatch_command Ȃ) ɂ
  //   OBC󂯂R}hʂւƕϊD
  /*
  // s͑SẴR}h̎sʂRealTimeɐݒ肷B
  // ^CC͂ŃA^CɕϊB
  // ͓̏ɕ@ŃpPbg[eBOsꍇdvB
  // ʂ̓[eBO̓[eBÕ^CC󂯕tȂ͂B
  CCP_set_exec_type(&packet_, CCP_EXEC_TYPE_RT);
  */

  // sL^R}hsB
  cdis->prev.time = TMGR_get_master_clock();
  cdis->prev.code = CCP_get_id(&packet_);
  cdis->prev.sts  = PH_dispatch_command(&packet_);

  // sR}hXgj
  PL_drop_executed(cdis->pli);

  if (cdis->prev.sts != CCP_EXEC_SUCCESS)
  {
    // sR}hsُXe[^XԂꍇB
    // G[JE^JEgAbvB
    ++(cdis->error_counter);

    if (cdis->stop_on_error == 1)
    {
      // ُ펞sftOLȏꍇB
      // stO𖳌ȍ~̎s𒆒fB
      cdis->lockout = 1;
    }
  }
}

void CDIS_clear_command_list(CommandDispatcher* cdis)
{
  // ێĂ郊Xg̓eNA
  PL_clear_list(cdis->pli);
}

void CDIS_clear_error_status(CommandDispatcher* cdis)
{
  // sG[ԂԂɕ
  cdis->prev_err = CEI_init_();

  // ώZG[񐔂0NA
  cdis->error_counter = 0;
}
#pragma section
