/**
 * @file  packet_list.h
 * @brief CTCP̃XgƂẴf[^\`. ЕXgƂĎĂ
 */
#ifndef PACKET_LIST_H_
#define PACKET_LIST_H_

#include <stddef.h>

#include "common_tlm_cmd_packet.h"
#include "block_command_table.h"

/**
 * @struct PL_NodeTag
 * @brief  ЕXg\em[h
 */
struct PL_NodeTag
{
  CTCP packet;
  struct PL_NodeTag* next;
};
typedef struct PL_NodeTag PL_Node;

/**
 * @struct PacketList
 * @brief  pPbgXg{
 * @note   f[^\ƂĂ ЕXg
 *         ł͊OŎOɗ̈悾mۂĂPL_Nodez̐擪|C^stockɕۑĘAXg, inactive_list_headɂRs[.
           gƂɂinactive_listPL_Nodeo, ̗̈active_listɑ}.
           Ȃo[͑S private
 */
typedef struct
{
  uint16_t total_nodes_;        //!< Sm[h (static m)
  uint32_t executed_nodes_;     //!< sꂽm[h
  uint16_t active_nodes_;       //!< ݕЕXgɓĂm[h

  PL_Node* stock_;              //!< mۂĂ̈Ŝ̐擪
  PL_Node* inactive_list_head_; //!< mۂĂ̈̓AgĂȂ̂̐擪, stack
  PL_Node* active_list_head_;   //!< mۂĂ̈̓AgĂ̂̐擪
  PL_Node* active_list_tail_;   //!< mۂĂ̈̓AgĂ̖̂[
} PacketList;

/**
 * @enum  PL_ACK
 * @brief PacketList ֘ÃG[R[h
 * @note  uint8_t
 */
typedef enum
{
  PL_SUCCESS,            //!< 
  PL_LIST_FULL,          //!< PacketList t (inactive )
  PL_TLC_PAST_TIME,      //!< sԊɌo
  PL_TLC_ALREADY_EXISTS, //!< Ɋ Node 
  PL_TLC_ON_TIME,        //!< sx
  PL_TLC_NOT_YET,        //!< ܂sł͂Ȃ
  PL_BC_INACTIVE_BLOCK,  //!<  BC
  PL_BC_LIST_CLEARED,    //!< PL NA (, active S폜) ꂽ
  PL_BC_TIME_ADJUSTED,   //!<  Node ߒꂽ
  PL_NO_SUCH_NODE        //!<  Node ͖
} PL_ACK;

/**
 * @brief static Ɋmۂꂽ PL_Node z󂯎肻̗̈gp PL 
 * @param[in] stock: gp PL_Node z
 * @param[in] size_t: z̃TCY
 * @param[out] pli:  PacketList
 * @return void
 */
void PL_initialize(PL_Node* stock, size_t size, PacketList* pli);

/**
 * @brief PacketList NA
 * @param[in] pli: NA PacketList
 * @return void
 * @note S active Node 폜 S inactive  stock ɂ
 */
void PL_clear_list(PacketList* pli);

/**
 * @brief PacketList Ŏsꂽm[hԂ
 * @param[in] pli: PacketList
 * @return uint32_t: sꂽm[h
 */
const uint32_t PL_count_executed_nodes(const PacketList* pli);

/**
 * @brief PacketList ŗL(s҂)m[hԂ
 * @param[in] pli: PacketList
 * @return uint16_t: L(s҂)m[h
 */
const uint16_t PL_count_active_nodes(const PacketList* pli);

/**
 * @brief PacketList ŎgpĂȂm[hԂ
 * @param[in] pli: PacketList
 * @return uint16_t: gpĂȂm[h
 */
const uint16_t PL_count_inactive_nodes(const PacketList* pli);

/**
 * @brief PacketList 󂩂ǂ
 * @param[in] pli: PacketList
 * @return int 1: True 0: False
 */
int PL_is_empty(const PacketList* pli);

/**
 * @brief PacketList tǂ
 * @param[in] pli: PacketList
 * @return int 1: True 0: False
 */
int PL_is_full(const PacketList* pli);

/**
 * @brief PacketList  active 擪m[h擾
 * @param[in] pli: PacketList
 * @return const PL_Node*
 */
const PL_Node* PL_get_head(const PacketList* pli);

/**
 * @brief PacketList  active [m[h擾
 * @param[in] pli: PacketList
 * @return const PL_Node*
 */
const PL_Node* PL_get_tail(const PacketList* pli);

/**
 * @brief Node 擾
 * @param[in] node: m[h
 * @return const PL_Node*
 */
const PL_Node* PL_get_next(const PL_Node* node);

/**
 * @brief PacketList ̐擪 packet }
 * @param[in] pli: PacketList
 * @param[in] packet: } packet
 * @return PL_ACK
 */
PL_ACK PL_push_front(PacketList* pli, const CTCP* packet);

/**
 * @brief PacketList ̖ packet }
 * @param[in] pli: PacketList
 * @param[in] packet: } packet
 * @return PL_ACK
 */
PL_ACK PL_push_back(PacketList* pli, const CTCP* packet);

/**
 * @brief  Node ̒ packet }
 * @param[in] pli: PacketList
 * @param[in] pos: ɑ} packet
 * @param[in] packet: } packet
 * @return PL_ACK
 */
PL_ACK PL_insert_after(PacketList* pli, PL_Node* pos, const CTCP* packet);

/**
 * @brief  Node ̒ packet }
 * @param[in] pli: PacketList
 * @param[in] packet: } packet
 * @param[in] now: ̎ws
 * @return PL_ACK
 * @note TaskList  TimeLine ĝ now  uint32_t
 */
PL_ACK PL_insert_tl_cmd(PacketList* pli, const CTCP* packet, uint32_t now);

/**
 * @brief PacketList  BC WJ
 * @param[in] pli: PacketList
 * @param[in] block: WJ BC  ID
 * @param[in] start_at: Jn
 * @return PL_ACK
 * @note TaskList  TimeLine ĝ start_at  uint32_t
 */
PL_ACK PL_deploy_block_cmd(PacketList* pli, const bct_id_t block, uint32_t start_at);

/**
 * @brief PacketList ̐擪 time r
 * @param[in] pli: PacketList
 * @param[in] time: r鎞
 * @return PL_ACK
 * @note TaskList  TimeLine ĝ start_at  time
 */
PL_ACK PL_check_tl_cmd(PacketList* pli, uint32_t time);

/**
 * @brief 擪m[h𗎂Ƃ
 * @param[in] pli: PacketList
 * @return void
 */
void PL_drop_executed(PacketList* pli);

/**
 * @brief w肳ꂽm[h𗎂Ƃ
 * @param[in] pli: PacketList
 * @param[in] prev: ƂO Node
 * @param[in] current: Ƃ Node
 * @return void
 */
void PL_drop_node(PacketList* pli, PL_Node* prev, PL_Node* current);

#endif
