/**
 * @file telemetry_frame.h
 * @brief  eg̓o^Ceg֘A
 */
#ifndef TELEMETRY_FRAME_H_
#define TELEMETRY_FRAME_H_

#include "./common_tlm_cmd_packet.h"

#define TF_TLM_PAGE_SIZE (64)                                    //!< ee[u1egpPbg(=1y[W)Ɋi[e
#define TF_TLM_PAGE_MAX  (4)                                     //!< ee[uy[Wiy[Wl[Vpj
#define TLM_MAX_TLMS     (TF_TLM_PAGE_SIZE * TF_TLM_PAGE_MAX)    //!< ee[uTCYDȂ킿o^łőe

#include <src_user/Settings/CmdTlm/telemetry_frame_params.h>

typedef struct
{
  int (*tlm_func)(unsigned char*, int);
} TlmInfo;

typedef enum
{
  TLM_SUCCESS = 0,
  TLM_TOO_SHORT_LEN = -1,
  TLM_NOT_DEFINED = -2,
  TLM_UNKNOWN = -3
} TLM_ACK;

extern const TlmInfo* tlm_table;
extern const int* TF_page_no;

void TF_initialize(void);

int TF_generate_contents(int packet_id,
                         unsigned char* contents,
                         int max_len);

/**
 * @brief  Tlm Tablẽ[h
 * @note   ` /src_user/CmdTlm/TelemetryDefinitions.c ɂ
 * @param  tlm_table_: Tlm Table̎
 * @return void
 */
void TF_load_tlm_table(TlmInfo tlm_table_[TLM_MAX_TLMS]);

CCP_EXEC_STS Cmd_TF_REGISTER_TLM(const CTCP* packet);

CCP_EXEC_STS Cmd_TF_SET_PAGE_FOR_TLM(const CTCP* packet);

void TF_copy_u8(uint8_t* ptr,
                uint8_t data);

void TF_copy_u16(uint8_t* ptr,
                 uint16_t data);

void TF_copy_u32(uint8_t* ptr,
                 uint32_t data);

void TF_copy_i8(uint8_t* ptr,
                int8_t data);

void TF_copy_i16(uint8_t* ptr,
                 int16_t data);

void TF_copy_i32(uint8_t* ptr,
                 int32_t data);

void TF_copy_float(uint8_t* ptr,
                   float data);

void TF_copy_double(uint8_t* ptr,
                    double data);

#endif
