/**
 * @file   driver_super.h
 * @brief  eZTEAN`G[^Ƃ̃C^[tF[XhCoQ̃X[p[NX
 *
 *         DriverSuper Class 
 *         eZTEAN`G[^Ƃ̃C^[tF[XC
 *         CR}hsCegNGXgCegMCeg͂ȂǂsChCoQ̃X[p[NXłD
 *         X̋@̃C^[tF[XhCoɌpĎgp܂D
 */
#ifndef DRIVER_SUPER_H_
#define DRIVER_SUPER_H_

#include <src_user/IfWrapper/if_list.h>
#include <src_user/Library/stdint.h>
#include "../../Library/endian_memcpy.h"        // pXsȎR[hނŎg悤
#include "../../System/TimeManager/time_manager.h"
// #include <src_user/CmdTlm/CCSDS/TCPacket.h>


#define DS_STREAM_MAX          (3)         /*!< DS_StreamConfig̍ő吔
                                                uint8_t z          */
#define DS_RX_BUFFER_SIZE_MAX  (1024)      //!< Mf[^obt@̍ő咷
#define DS_RX_FRAME_SIZE_MAX   (1024)      //!< Mf[^t[̍ő咷

#include <src_user/Settings/DriverSuper/driver_super_params.h>

/**
 * @enum   DS_DRIVER_ERR_CODE
 * @brief  Driver ̔ėpG[R[h
 *
 *         Driver ̊esetter ̊֐ԂlŎg邱Ƃz
 * @note   uint8_t z
 * @note   ֐ĂяoɂẮC DS_INIT_ERR_CODE p邱
 * @note   M֐ĂяoɂẮC DS_REC_ERR_CODE p邱
 * @note   ڑ@֑CmdĂяoɂẮC DS_CMD_ERR_CODE p邱
 * @note   DI  Cmd ̕Ԃlł CCP_EXEC_STS Ƃ̐𑽏ӎĂ
 * @note   CCP_EXEC_STS ւ̕ϊ DS_conv_driver_err_to_ccp_exec_sts p
 * @note   ڍׂȃG[Ԃꍇ́C Driver ƂɓƎ enum `ėǂ
 */
typedef enum
{
  DS_DRIVER_ERR_CODE_OK = 0,                //!< OK
  DS_DRIVER_ERR_CODE_ILLEGAL_CONTEXT,       //!< CCP_EXEC_ILLEGAL_CONTEXT ɑΉ
  DS_DRIVER_ERR_CODE_ILLEGAL_PARAMETER,     //!< CCP_EXEC_ILLEGAL_PARAMETER ɑΉ
  DS_DRIVER_ERR_CODE_ILLEGAL_LENGTH,        //!< CCP_EXEC_ILLEGAL_PARAMETER ɑΉ
  DS_DRIVER_ERR_CODE_UNKNOWN_ERR = 255      //!< UNKNOWN ERR
} DS_DRIVER_ERR_CODE;


/**
 * @enum   DS_INIT_ERR_CODE
 * @brief  Driver ̏֐̃G[R[h
 * @note   uint8_t z
 */
typedef enum
{
  DS_INIT_OK = 0,               //!< OK
  DS_INIT_DS_INIT_ERR,          //!< DS_init ł̃G[
  DS_INIT_PARAMETER_ERR,        //!< p^G[
  DS_INIT_OTHER_ERR,            //!< ̑̃G[
  DS_INIT_UNKNOWN_ERR = 255     //!< UNKNOWN ERR
} DS_INIT_ERR_CODE;


/**
 * @enum   DS_REC_ERR_CODE
 * @brief  Driver ̎M֐̃G[R[h
 * @note   uint8_t z
 */
typedef enum
{
  DS_REC_OK = 0,                //!< OK
  DS_REC_DS_RECEIVE_ERR,        //!< DS_receive ł̃G[
  DS_REC_ANALYZE_ERR,           //!< DS_analyze_rec_data ł̃G[
  DS_REC_OTHER_ERR,             //!< ̑̃G[
  DS_REC_UNKNOWN_ERR = 255      //!< UNKNOWN ERR
} DS_REC_ERR_CODE;


/**
 * @enum   DS_CMD_ERR_CODE
 * @brief  eDI Driver ɃR}h𑗂ƂɁCIɎgR[h
 * @note   uint8_t z
 * @note   DI  Cmd ̕Ԃlł CCP_EXEC_STS Ƃ̐𑽏ӎĂ
 * @note   CCP_EXEC_STS ւ̕ϊ DS_conv_cmd_err_to_ccp_exec_sts p
 */
typedef enum
{
  DS_CMD_OK                 = 0,   //!< OK0ł邱Ƃۏ؂
  DS_CMD_ILLEGAL_CONTEXT    = 1,   //!< CCP_EXEC_ILLEGAL_CONTEXT ɑΉDDIł݂邱Ƃ͂DHWˑDriverł݂
  DS_CMD_ILLEGAL_PARAMETER  = 2,   //!< CCP_EXEC_ILLEGAL_PARAMETER ɑΉDq[^[̌ȂǁCHWˑDrivreł݂
  DS_CMD_ILLEGAL_LENGTH     = 3,   //!< CCP_EXEC_ILLEGAL_LENGTH ɑΉD͊{IɂDIŌ͂Ȃ̂ŁCgȂƂz
  DS_CMD_DRIVER_SUPER_ERR   = 4,   //!< DriverSuperC܂z̒჌C[ŃG[Nꍇ
  DS_CMD_UNKNOWN_ERR        = 255
} DS_CMD_ERR_CODE;


/**
 * @enum   DS_ERR_CODE
 * @brief  DriverSuper ̔ėpG[R[h
 * @note   uint8_t z
 * @note   DriverSuper ŗpC Drive ł͗pȂ
 */
typedef enum
{
  DS_ERR_CODE_OK   = 0,     //!< Ԃl͌pIFŏ㏑邽߁COK0ł邱ƂK{
  DS_ERR_CODE_ERR  = 1
} DS_ERR_CODE;


/**
 * @enum   DS_RX_DISRUPTION_STATUS_CODE
 * @brief  Mr┻R[h
 * @note   uint8_t z
 */
typedef enum
{
  DS_RX_DISRUPTION_STATUS_OK   = 0,  //!< Mr₵ĂȂ or Mr┻Ȃ
  DS_RX_DISRUPTION_STATUS_LOST = 1   //!< Mr⌟o
} DS_RX_DISRUPTION_STATUS_CODE;


/**
 * @struct DS_RecStatus
 * @brief  IF M
 */
typedef struct
{
  int                          ret_from_if_rx;       //!< IF_RX ̕Ԃl
  DS_RX_DISRUPTION_STATUS_CODE rx_disruption_status; //!< Mr┻
} DS_RecStatus;


/**
 * @enum   DS_STREAM_SEND_STATUS_CODE
 * @brief  DS_StreamSendStatus łDR}hM̏Ԃ
 * @note   uint8_t z
 */
typedef enum
{
  DS_STREAM_SEND_STATUS_OK,
  DS_STREAM_SEND_STATUS_DISABLE,
  DS_STREAM_SEND_STATUS_TX_ERR,                //!< IF_TXŃG[
  DS_STREAM_SEND_STATUS_VALIDATE_ERR,          //!< MOvalidate_configŃG[
  DS_STREAM_SEND_STATUS_OTHER_ERR
} DS_STREAM_SEND_STATUS_CODE;


/**
 * @struct DS_StreamSendStatus
 * @brief  t[M
 */
typedef struct
{
  DS_STREAM_SEND_STATUS_CODE status_code;       //!< status
  int                        ret_from_if_tx;    //!< IF_TX ̕Ԃl
  // ڍ׏gȂCɓ
} DS_StreamSendStatus;


/**
 * @enum   DS_STREAM_REC_STATUS_CODE
 * @brief  DS_StreamRecStatus łDeM̏ԑJڂ
 * @note   uint8_tz
 */
typedef enum
{
  DS_STREAM_REC_STATUS_FINDING_HEADER,
  DS_STREAM_REC_STATUS_RECEIVING_HEADER,
  DS_STREAM_REC_STATUS_RECEIVING_FRAMELENGTH, //!< ϒt[ł́Ct[f[^M
  DS_STREAM_REC_STATUS_RECEIVING_DATA,
  DS_STREAM_REC_STATUS_RECEIVING_FOOTER,
  DS_STREAM_REC_STATUS_FIXED_FRAME,
  DS_STREAM_REC_STATUS_DISABLE,
  DS_STREAM_REC_STATUS_HEADER_MISMATCH,
  DS_STREAM_REC_STATUS_FOOTER_MISMATCH,
  DS_STREAM_REC_STATUS_RX_FRAME_TOO_LONG,
  DS_STREAM_REC_STATUS_RX_FRAME_TOO_SHORT,
  DS_STREAM_REC_STATUS_RX_ERR,                //!< IF_RX ŃG[
  DS_STREAM_REC_STATUS_VALIDATE_ERR,          //!< MOvalidate_configŃG[
  DS_STREAM_REC_STATUS_OTHER_ERR
} DS_STREAM_REC_STATUS_CODE;


/**
 * @enum   DS_STREAM_RX_DISRUPTION_STATUS_CODE
 * @brief  er┻R[h
 * @note   uint8_t z
 */
typedef enum
{
  DS_STREAM_TLM_DISRUPTION_STATUS_OK   = 0,  //!< er₵ĂȂ or er┻Ȃ
  DS_STREAM_TLM_DISRUPTION_STATUS_LOST = 1   //!< er⌟o
} DS_STREAM_TLM_DISRUPTION_STATUS_CODE;


/**
 * @struct DS_StreamRecStatus
 * @brief  t[M
 */
typedef struct
{
  DS_STREAM_REC_STATUS_CODE            status_code;                   //!< status
  uint16_t                             fixed_frame_len;               //!< t[m肵Ƃ̃t[
  DS_STREAM_TLM_DISRUPTION_STATUS_CODE tlm_disruption_status;         //!< er┻
  uint32_t                             count_of_carry_over_failures;  /*!< Mobt@̌JzɎs
                                                                           DS_receive ̌Ăяopx邱Ƃ */
  // ڍ׏gȂCɓiref. EQU Driver Super  DRIVE_Super_recȂǁj
} DS_StreamRecStatus;


/**
 * @struct DS_Config
 * @brief  DriverSuper ̐ݒ
 *
 *         eIF͂pĂD
 */
typedef struct
{
  // y[U[ݒ^擾lziDS_Config̕ϐׂ͂ĂDriverJƂj
  DS_RecStatus rec_status_;                                 //!< IFM

  uint32_t rx_count_;                                       //!< Ȃɂ̃f[^̎M
  uint32_t rx_call_count_;                                  //!< DS_receive Ăяo

  ObcTime  rx_time_;                                        //!< Ȃɂ̃f[^̎M

  uint8_t  should_monitor_for_rx_disruption_;               //!< Mr┻邩H
  uint32_t time_threshold_for_rx_disruption_;               //!< Mr┻臒l [ms]

  // yŗplz
  uint8_t rx_buffer_[DS_RX_BUFFER_SIZE_MAX];                //!< f[^Mobt@

  DS_ERR_CODE (*load_init_setting)(struct DriverSuper* p_super);
                                                            /*!< DS_init Ń[hChCȍݒ̐ݒ֐
                                                                 DS_reset_config ł̐ݒI[o[[h
                                                                 Ԃl DS_ERR_CODE */
} DS_Config;


/**
 * @struct DS_StreamConfig
 * @brief  DriverSuperStream̐ݒ
 */
struct DS_StreamConfig
{
  // yp܂ŌJz
  // Ȃ
  // setter/getterő삷

  // y[U[ݒ^擾lziDS_StreamConfig̕ϐׂ͂ĂDriverJƂj
  uint8_t  is_enabled_;                                     //!< LH

  uint8_t  is_strict_frame_search_;                         /*!< iȃt[TLH
                                                                 mCY╡streamgpɃt[MRSɂȂ[h
                                                                 - OFF̏ꍇiʏ͂j
                                                                    wb_āCt[C̃t[̓t[₩T
                                                                 - ON̏ꍇ
                                                                    wb_āCt[C̃t[́Cwb_擪̎oCgT
                                                                    sԂ͒Ȃ
                                                                 streammCYĂ܂ꍇȂǁC{wb_łȂwb_ƂĔFĂ܂ꍇɗLƁC
                                                                 _Iȃt[MR̊mȂOɋ߂Â邱ƂłD
                                                                 wb_t[̏ꍇ̂݁CLɂł */

  DS_StreamSendStatus send_status_;                         //!< t[M
  DS_StreamRecStatus  rec_status_;                          //!< t[M

  uint32_t general_cmd_tx_count_;                           //!< ʏR}hM
  uint32_t req_tlm_cmd_tx_count_;                           //!< evR}hM
  uint32_t req_tlm_cmd_tx_count_after_last_tx_;             /*!< ŌɃeMẴevR}hM
                                                                 ꂪ 0 łȂꍇCeŐVł͂Ȃ\ */
  uint32_t rx_frame_fix_count_;                             //!< t[Mm

  ObcTime  general_cmd_tx_time_;                            //!< ʏR}hŏIM
  ObcTime  req_tlm_cmd_tx_time_;                            //!< evR}hŏIM
  ObcTime  rx_frame_fix_time_;                              //!< t[m莞

  uint8_t  *tx_frame_;                                      //!< R}ht[
  uint16_t tx_frame_size_;                                  /*!< R}ht[TCY
                                                                 Mf[^Ȃꍇ 0 */

  uint8_t  rx_frame_[DS_RX_FRAME_SIZE_MAX];                 /*!< f[^Mt[obt@
                                                                 DS_RX_FRAME_SIZE_MAX 𒴂悤ȋȃt[irbOf[^jɂ͖Ήi\j
                                                                 ΉꍇC̔zϐȎ傫Ȕz̃|C^ɏ㏑KvD */

  const uint8_t* rx_header_;                                //!< Mf[^̃wb_
  uint16_t rx_header_size_;                                 /*!< Mf[^̃wb_TCY
                                                                 wb_Ȃꍇ0ɐݒ
                                                                 ̏ꍇC{Iɂ͌Œ蒷i rx_frame_size jgD
                                                                 wb_ȂCϒ̏ꍇ́CMOiႦ DS_send_req_tlm_cmd ĂяoOj 
                                                                 rx_frame_size_ ݒ肷邱ƂŌŒ蒷̂悤ɈƂőΉD
                                                                 ܂C Validation ʂ߂ɂCl͓K؂ȐɂĂ */
  const uint8_t  *rx_footer_;                               //!< Mf[^̃tb^
  uint16_t rx_footer_size_;                                 /*!< Mf[^̃tb^TCY
                                                                 wb_Ȃꍇ0ɐݒ */
  int16_t  rx_frame_size_;                                  /*!< Mf[^iegjt[TCY
                                                                 Mf[^Ȃꍇ0ɐݒ
                                                                 Mf[^ς̏ꍇ͕ɐݒ */
  int16_t  rx_framelength_pos_;                             /*!< Mf[^̃t[TCYf[^݂̑ꏊi擪琔ĉ byte ڂɈʒu邩D0 NZj
                                                                 Mf[^ϒ̏ꍇ̂ݎgpD
                                                                 t[TCYf[^Ȃꍇɂ͕ɐݒ肷D
                                                                 ϒłt[TCYf[^̂Ȃt[́Ctb^ݒ肳Ăꍇ͗LłD
                                                                 Ctb^̒TKvȂ߁CsԂ͎኱xȂD
                                                                 Cwb_邱Ƃ𐄏Dwb_Ȃꍇ́CMf[^̖`t[Ƃ݂ȂD
                                                                 Mt[MOɔĂꍇ́C
                                                                 wb_Ȃꍇ̂ƂƓlɁCMOiႦ DS_send_req_tlm_cmd ĂяoOj 
                                                                 rx_frame_size_ ݒ肷邱ƂŁCŒ蒷̂悤ɈƂőΉ邱Ƃ𐄏D */
  uint16_t rx_framelength_type_size_;                       /*!< t[TCYf[^̌^TCY [Byte]
                                                                 Mf[^ϒ̏ꍇ̂ݎgpD
                                                                 Ⴆ uint8 Ȃ 1C uint32 Ȃ 4 */
  uint16_t rx_framelength_offset_;                          /*!< t[TCYf[^̃ItZbgl
                                                                 Mf[^ϒ̏ꍇ̂ݎgp
                                                                 t[TCYf[^ɂϒf[^̉͂́ut[̑STCYvɂs邪C
                                                                 @̒ɂ̓wb_ƃtb^̕͏f[^ƂăTCY\ꍇ
                                                                 ̏ꍇ̃TCŶ߂Ɏg
                                                                 t[TCYf[^ut[̑STCYvĂꍇɂ0ɐݒ肷 */

  uint8_t  should_monitor_for_tlm_disruption_;              //!< er┻邩H
  uint32_t time_threshold_for_tlm_disruption_;              //!< er┻臒l [ms]

  DS_ERR_CODE (*data_analyzer_)(struct DS_StreamConfig* p_stream_config, void* p_driver);
                                                            /*!< Mf[^̉͊֐
                                                                 p_driver ͌p@̃hCo\̂Ȃ
                                                                 Ԃl DS_ERR_CODE */
  DS_ERR_CODE ret_from_data_analyzer_;                      //!< data_analyzer_ ̕Ԃl

  // yŗplz
  uint8_t  is_validation_needed_for_send_;                  //!< MOɐݒl Validation KvH
  uint8_t  is_validation_needed_for_rec_;                   //!< MOɐݒl Validation KvH

  uint16_t rx_frame_rec_len_;                               //!< Mf[^t[̎MςByteDrx_frame_ ɑ΂鑀|C^ɂȂ
  uint16_t rx_frame_head_pos_of_frame_candidate_;           /*!< Mobt@͎ɁCt[Ƃt[̐擪ʒui0 NZj
                                                                 DS_analyze_rx_buffer_fixed_, DS_analyze_rx_buffer_variable_ Ă΂֐ŁC
                                                                 t[₪WJȃG[itb^̕svt[̕sjNɁC
                                                                 ēxt[Tł悤ɂ邽߂Ɏg */

  uint8_t  is_rx_buffer_carry_over_;                        //!< JzMf[^邩H
  uint16_t carry_over_buffer_size_;                         //!< JzMf[^̃TCY
  uint16_t carry_over_buffer_next_pos_;                     //!< Tn߂obt@ʒui0 NZj
  uint8_t  rx_buffer_for_carry_over_[DS_RX_BUFFER_SIZE_MAX];
                                                            /*!< t[m肵ƂɁČɑĂMf[^Jz߂̕ۑpobt@
                                                                 ̎Mɂ܂Ƃ߂ď */
};
typedef struct DS_StreamConfig DS_StreamConfig;
//  (*data_analyzer_)(DS_StreamConfig* p_stream_config, void* p_driver);  DS_StreamConfig OQƂłȂ̂ŁCĂ邪CCCƗǂ肻D


/**
 * @struct DriverSuper
 * @brief  DriverSuper̐ݒ
 *         eIF͂pĂD
 */
struct DriverSuper
{
  // yp܂ŌJz
  IF_LIST_ENUM      interface;                              //!< p̋@̎gpIF
  void              *if_config;                             //!< IFݒ

  DS_Config         config;                                 //!< DriverSuper̐ݒ

  DS_StreamConfig   stream_config[DS_STREAM_MAX];           /*!< DriverSuperStream
                                                                 indexႢ̂قǗDiɍシ邩DsxjD
                                                                 gF[0]݂̂āCeɎd TLM ID Ȃǂ data_analyzer_ ŏ𕪊
                                                                 gF[0]eƈʃR}hŎgC[1]ȍ~R}hEegŎg
                                                                 C܂RɎgĂ炦 */
};
typedef struct DriverSuper DriverSuper;
//  (*load_init_setting)(struct DriverSuper* p_super);  DriverSuper OQƂłȂ̂ŁCĂ邪CCCƗǂ肻D


// ###### DriverSuper{֐ ######

/**
 * @brief  p̋@DriverSuper
 *
 *         DriverSuper\̂pDrive\̂̃oƂĒ`ipjC|C^nƂŃ|[gD
 *         āC\̓̏KvȕϐD
 *         ftHgl̏㏑ load_init_setting ōs
 * @note   DriverSupergp鎞͋NɕK{邱
 * @param  *p_super           DriverSuper\̂ւ̃|C^
 * @param  *if_config         DriverŗpĂIFconfig\
 * @param  *load_init_setting DriverSupeȑݒ胍[h֐|C^
 * @return DS_ERR_CODE
 */
DS_ERR_CODE DS_init(DriverSuper* p_super,
                    void* if_config,
                    DS_ERR_CODE (*load_init_setting)(DriverSuper* p_super));

/**
 * @brief  DriverSuper̃Zbg
 * @note   DS_initŌĂ΂ĂD
 * @param  *p_super DriverSuper\̂ւ̃|C^
 * @return DS_ERR_CODE
 */
DS_ERR_CODE DS_reset(DriverSuper* p_super);

/**
 * @brief  DriverSuper̐ݒɕsĂȂ`FbN
 *
 *         Driver̐ݒςꍇ͖ĂяoƂ𐄏
 * @note   DS_initŌĂ΂ĂD
 * @note   ̊ǗtOύXĂ̂ŁC p_super Ɍconst͂Ȃ
 * @param  *p_super DriverSuper\̂ւ̃|C^
 * @return DS_ERR_CODE
 */
DS_ERR_CODE DS_validate_config(DriverSuper* p_super);

/**
 * @brief  Mobt@NA
 *
 *         Ⴆ΁Cwb_ȂȅꍇCrŃS~f[^ƈȌシׂẴt[Ă܂D
 *         ̂悤ȂƂiCRCG[łƂCMf[^炩ɂꍇjɁCbufferxNAC
 *         ɓ͂f[^t[͂擪s悤ɂ邽߂ɗpD
 * @param  *p_super DriverSuper\̂ւ̃|C^
 * @return DS_ERR_CODE
 */
DS_ERR_CODE DS_clear_rx_buffer(DriverSuper* p_super);

/**
 * @brief  p̋@킩egM
 *
 *         t[m肳āCrx_frame_ɂ܂ŁD (data_analyzer_) ͂Ȃ̂ŃhCo DS_analyze_rec_data Ăяo
 *         ́CstreamłeIDȂǂŉ͂ςƂȂǂz肳邽
 * @note   p̋@̃f[^o͎葁ŒIɎs邱
 * @param  *p_super DriverSuper\̂ւ̃|C^
 * @retval DS_ERR_CODE_OK  : IF_RX ł̃G[Ȃ
 * @retval DS_ERR_CODE_ERR : IF_RX ł̃G[
 * @note   M󋵂G[ rec_status_ Ɋi[Ă
 */
DS_ERR_CODE DS_receive(DriverSuper* p_super);

/**
 * @brief  data_analyzer_ ĂяoCMf[^͂D
 *
 *         DS_receive ɂăf[^MC DSSC_get_rec_status(p_stream_config)->status_code  DS_STREAM_REC_STATUS_FIXED_FRAME ȂΌĂяoD
 * @param  *p_super DriverSuper\̂ւ̃|C^
 * @param  stream   ǂstream_configgp邩Dstream0-MAXȂ̂ŁCpENUMȂǐ錾Ďg₷΂ƎvD
 * @param  p_driver p@̃hCo\̂ȂǁDdata_analyzer_ ̑D
 * @return DS_ERR_CODE : data_analyzer_ ̕Ԃl̂܂ܕԂ
 * @note   data_analyzer_ ̕ԂĺC ret_from_data_analyzer_ ɂۑD
 */
DS_ERR_CODE DS_analyze_rec_data(DriverSuper* p_super, uint8_t stream, void* p_driver);

/**
 * @brief  p̋@ɈʃR}h𔭍s
 *
 *         ̃R}h𑗂ƂɂăX|XԂĂ邱Ƃz肵ĂȂȉꍇ DS_send_req_tlm_cmd gj
 * @note   ̊֐̎sOɁCtx_frame, tx_frame_size̐ݒ肪Kvł
 * @note   ͊NXȂ߁CAm}s͍sȂDpŕԂlēK؂ɃAm}s邱
 * @param  *p_super DriverSuper\̂ւ̃|C^
 * @param  stream   ǂstream_configgp邩Dstream0-MAXȂ̂ŁCpENUMȂǐ錾Ďg₷΂ƎvD
 * @retval DS_ERR_CODE_OK  : I
 * @retval DS_ERR_CODE_ERR : IF_TX ł̃G[
 * @note   M󋵂G[ send_status_ Ɋi[Ă
 */
DS_ERR_CODE DS_send_general_cmd(DriverSuper* p_super, uint8_t stream);

/**
 * @brief  p̋@ɃevR}h𔭍s
 *
 *         eɂĂ DS_receive Ŏ󂯎D
 * @note   ̊֐̎sOɁCtx_frame, tx_frame_size̐ݒ肪Kvł
 * @param  *p_super DriverSuper\̂ւ̃|C^
 * @param  stream   ǂstream_configgp邩Dstream0-MAXȂ̂ŁCpENUMȂǐ錾Ďg₷΂ƎvD
 * @retval DS_ERR_CODE_OK  : I
 * @retval DS_ERR_CODE_ERR : IF_TX ł̃G[
 * @note   M󋵂G[ send_status_ Ɋi[Ă
 */
DS_ERR_CODE DS_send_req_tlm_cmd(DriverSuper* p_super, uint8_t stream);

// ###### DS_Config Getter/Setter ######
const DS_RecStatus* DSC_get_rec_status(const DriverSuper* p_super);
const uint32_t DSC_get_rx_count(const DriverSuper* p_super);
const uint32_t DSC_get_rx_call_count(const DriverSuper* p_super);
const ObcTime* DSC_get_rx_time(const DriverSuper* p_super);

const uint8_t DSC_get_should_monitor_for_rx_disruption(const DriverSuper* p_super);
void DSC_enable_monitor_for_rx_disruption(DriverSuper* p_super);
void DSC_disable_monitor_for_rx_disruption(DriverSuper* p_super);
const uint32_t DSC_get_time_threshold_for_rx_disruption(const DriverSuper* p_super);
void DSC_set_time_threshold_for_rx_disruption(DriverSuper* p_super,
                                              const uint32_t time_threshold_for_rx_disruption);
const DS_RX_DISRUPTION_STATUS_CODE DSC_get_rx_disruption_status(const DriverSuper* p_super);

// ###### DS_StreamConfig Getter/Setter ######
const uint8_t DSSC_get_is_enabled(const DS_StreamConfig* p_stream_config);
void DSSC_enable(DS_StreamConfig* p_stream_config);
void DSSC_disable(DS_StreamConfig* p_stream_config);

const uint8_t DSSC_get_is_strict_frame_search(const DS_StreamConfig* p_stream_config);
void DSSC_enable_strict_frame_search(DS_StreamConfig* p_stream_config);
void DSSC_disable_strict_frame_search(DS_StreamConfig* p_stream_config);

const DS_StreamSendStatus* DSSC_get_send_status(const DS_StreamConfig* p_stream_config);
const DS_StreamRecStatus* DSSC_get_rec_status(const DS_StreamConfig* p_stream_config);

const uint32_t DSSC_get_general_cmd_tx_count(const DS_StreamConfig* p_stream_config);
const uint32_t DSSC_get_req_tlm_cmd_tx_count(const DS_StreamConfig* p_stream_config);
const uint32_t DSSC_get_req_tlm_cmd_tx_count_after_last_tx(const DS_StreamConfig* p_stream_config);
const uint32_t DSSC_get_rx_frame_fix_count(const DS_StreamConfig* p_stream_config);

const ObcTime* DSSC_get_general_cmd_tx_time(const DS_StreamConfig* p_stream_config);
const ObcTime* DSSC_get_req_tlm_cmd_tx_time(const DS_StreamConfig* p_stream_config);
const ObcTime* DSSC_get_rx_frame_fix_time(const DS_StreamConfig* p_stream_config);

void DSSC_set_tx_frame(DS_StreamConfig* p_stream_config, uint8_t* tx_frame);
void DSSC_set_tx_frame_size(DS_StreamConfig* p_stream_config,
                            const uint16_t tx_frame_size);
const uint16_t DSSC_get_tx_frame_size(const DS_StreamConfig* p_stream_config);

const uint8_t* DSSC_get_rx_frame(const DS_StreamConfig* p_stream_config);
void DSSC_set_rx_header(DS_StreamConfig* p_stream_config,
                        const uint8_t* rx_header,
                        const uint16_t rx_header_size);
void DSSC_set_rx_footer(DS_StreamConfig* p_stream_config,
                        const uint8_t* rx_footer,
                        const uint16_t rx_footer_size);
void DSSC_set_rx_frame_size(DS_StreamConfig* p_stream_config,
                            const int16_t rx_frame_size);
const uint16_t DSSC_get_rx_header_size(const DS_StreamConfig* p_stream_config);
const uint16_t DSSC_get_rx_footer_size(const DS_StreamConfig* p_stream_config);
const int16_t DSSC_get_rx_frame_size(const DS_StreamConfig* p_stream_config);

void DSSC_set_rx_framelength_pos(DS_StreamConfig* p_stream_config,
                                 const int16_t rx_framelength_pos);
void DSSC_set_rx_framelength_type_size(DS_StreamConfig* p_stream_config,
                                       const uint16_t rx_framelength_type_size);
void DSSC_set_rx_framelength_offset(DS_StreamConfig* p_stream_config,
                                    const uint16_t rx_framelength_offset);

const uint8_t DSSC_get_should_monitor_for_tlm_disruption(const DS_StreamConfig* p_stream_config);
void DSSC_enable_monitor_for_tlm_disruption(DS_StreamConfig* p_stream_config);
void DSSC_disable_monitor_for_tlm_disruption(DS_StreamConfig* p_stream_config);
const uint32_t DSSC_get_time_threshold_for_tlm_disruption(const DS_StreamConfig* p_stream_config);
void DSSC_set_time_threshold_for_tlm_disruption(DS_StreamConfig* p_stream_config,
                                                const uint32_t time_threshold_for_tlm_disruption);
const DS_STREAM_TLM_DISRUPTION_STATUS_CODE DSSC_get_tlm_disruption_status(const DS_StreamConfig* p_stream_config);

void DSSC_set_data_analyzer(DS_StreamConfig* p_stream_config,
                            DS_ERR_CODE (*data_analyzer)(DS_StreamConfig* p_stream_config, void* p_driver));
const DS_ERR_CODE DSSC_get_ret_from_data_analyzer(const DS_StreamConfig* p_stream_config);


// ###### DriverėpUtil֐ ######

/**
 * @brief  DS_DRIVER_ERR_CODE  CCP_EXEC_STS ւ̕ϊ֐
 *
 *         DI  Driver ̊֐ĂяoƂ̃G[R[h̕ϊɗp
 * @note   ėpUtil֐
 * @param  DS_DRIVER_ERR_CODE
 * @return CCP_EXEC_STS
 */
CCP_EXEC_STS DS_conv_driver_err_to_ccp_exec_sts(DS_DRIVER_ERR_CODE code);

/**
 * @brief  DS_CMD_ERR_CODE  CCP_EXEC_STS ւ̕ϊ֐
 *
 *         DI  Driver ̊֐ĂяoƂ̃G[R[h̕ϊɗp
 * @note   ėpUtil֐
 * @param  DS_CMD_ERR_CODE
 * @return CCP_EXEC_STS
 */
CCP_EXEC_STS DS_conv_cmd_err_to_ccp_exec_sts(DS_CMD_ERR_CODE code);

#endif
