/**
 * @file   driver_super_issl_format.h
 * @brief  Driver̂߂ISSLtH[}bgʐM̂߂̌J`C֐Ȃ
 */
#ifndef DRIVER_SUPER_ISSL_FORMAT_H_
#define DRIVER_SUPER_ISSL_FORMAT_H_

#include "driver_super.h"
#include <src_user/Library/stdint.h>


#define DS_ISSLFMT_STX_SIZE             (2)          //!< ISSLWtH[}bgSTX̃TCY
#define DS_ISSLFMT_ETX_SIZE             (2)          //!< ISSLWtH[}bgETX̃TCY
#define DS_ISSLFMT_LEN_SIZE             (2)          //!< ISSLWtH[}bgLEÑTCY
#define DS_ISSLFMT_CRC_SIZE             (2)          //!< ISSLWtH[}bgCRC̃TCY
#define DS_ISSLFMT_COMMON_HEADER_SIZE   (DS_ISSLFMT_STX_SIZE + DS_ISSLFMT_LEN_SIZE)  //!< ISSLWtH[}bg̃Rwb_[̃TCY
#define DS_ISSLFMT_COMMON_FOOTER_SIZE   (DS_ISSLFMT_ETX_SIZE + DS_ISSLFMT_CRC_SIZE)  //!< ISSLWtH[}bg̃Rtb^[̃TCY
#define DS_ISSLFMT_CMD_HEADER_SIZE      (4)          //!< ISSLWtH[}bgCMDwb_[̃TCY
#define DS_ISSLFMT_TLM_HEADER_SIZE      (4)          //!< ISSLWtH[}bgTLMwb_[̃TCY
#define DS_ISSLFMT_STX_1ST_BYTE         (0xEB)       /*!< ISSLWtH[}bgSTX 1st byte̎擾
                                                          C2A`/C2A`ʂTLM HEADERdlł  */
#define DS_ISSLFMT_STX_2ND_BYTE         (0x90)       /*!< ISSLWtH[}bgSTX 2nd byte̎擾
                                                          C2A`/C2A`ʂTLM HEADERdlł  */
#define DS_ISSLFMT_ETX_1ST_BYTE         (0xC5)       /*!< ISSLWtH[}bgETX 1st byte̎擾
                                                          C2A`/C2A`ʂTLM HEADERdlł  */
#define DS_ISSLFMT_ETX_2ND_BYTE         (0x79)       /*!< ISSLWtH[}bgETX 2nd byte̎擾
                                                          C2A`/C2A`ʂTLM HEADERdlł  */


// [TODO] ȉ͖{TCP̒`玝ĂDTCP̐I炻
#define DS_C2AFMT_TCP_CMD_PRIMARY_HEADER_SIZE     (6)     //!< C2AԒʐMTCPCMD̂Primary header size
#define DS_C2AFMT_TCP_CMD_SECONDARY_HEADER_SIZE   (1)     //!< C2AԒʐMTCPCMD̂Secondary header size
#define DS_C2AFMT_TCP_TLM_PRIMARY_HEADER_SIZE     (6)     //!< C2AԒʐMTCPTLMPrimary header size
#define DS_C2AFMT_TCP_TLM_SECONDARY_HEADER_SIZE   (7)     //!< C2AԒʐMTCPTLMSecondary header sizeDADU


/**
 * @brief  TLM Version̎擾
 * @note   t[m肵ĂƂɌĂяo
 * @note   ͔C2A`ŎgTLM HEADERdlł
 * @param  p_stream_config DriverSuper\̂DS_StreamConfig
 * @return o[Wio[W 0x01łuint8_t̂߂uint32_tŕԂj
 */
uint32_t DS_ISSLFMT_get_tlm_version(const DS_StreamConfig* p_stream_config);

/**
 * @brief  TLM count̎擾
 * @note   t[m肵ĂƂɌĂяo
 * @note   ͔C2A`ŎgTLM HEADERdlł
 * @param  version         TLM Version
 * @param  p_stream_config DriverSuper\̂DS_StreamConfig
 * @return TLM countio[W 0x01łuint8_t̂߂uint32_tŕԂj
 */
uint32_t DS_ISSLFMT_get_tlm_count(const uint32_t version, const DS_StreamConfig* p_stream_config);

/**
 * @brief  TLM id̎擾
 * @note   t[m肵ĂƂɌĂяo
 * @note   ͔C2A`ŎgTLM HEADERdlł
 * @param  version         TLM Version
 * @param  p_stream_config DriverSuper\̂DS_StreamConfig
 * @return idio[W 0x01łuint16_t̂߂uint32_tŕԂj
 */
uint32_t DS_ISSLFMT_get_tlm_id(const uint32_t version, const DS_StreamConfig* p_stream_config);

/**
 * @brief  TLM length̎擾
 * @note   t[m肵ĂƂɌĂяo
 * @note   C2A`/C2A`ʂTLM HEADERdlł
 * @param  p_stream_config DriverSuper\̂DS_StreamConfig
 * @return idio[W 0x01łuint16_t̂߂uint32_tŕԂj
 */
uint32_t DS_ISSLFMT_get_tlm_length(const DS_StreamConfig* p_stream_config);

/**
 * @brief  CRČvZ
 * @note   CRC-16-IBMg
 * @note   C2A`/C2A`ʂTLM HEADERdlł
 * @param  c CRCvZf[^̃|C^
 * @return n f[^
 */
uint16_t DS_ISSLFMT_calc_crc(const unsigned char* c, size_t n);

/**
 * @brief  TLM id̎擾
 * @note   t[m肵ĂƂɌĂяo
 * @note   C2A`ŎgTLM HEADERdlł
 * @param  p_stream_config DriverSuper\̂DS_StreamConfig
 * @return id
 */
uint8_t DS_C2AFMT_get_tlm_id(const DS_StreamConfig* p_stream_config);

#endif
