/**
 * @file i2c.h
 * @brief I2CʐM(Master)̃bp[NXłB
 * @note I2CʐMbp[́A
 *       I2C̃C^[tF[XA
 *       I2C|[g̏Af[^MAf[^MsA
 *       I2CʐMbp[̃NXłB
 *       X̋@̃C^[tF[XW[ɌpĎgp܂B
 */

#ifndef I2C_H_
#define I2C_H_

#include <src_user/Library/stdint.h>

 /**
  * @struct I2cConfig
  * @brief I2C|[g̏Af[^MEM̍ۂɕKvƂȂݒi[\̂łB
  */
typedef struct
{
  uint8_t  ch;                 //!< p̋@킪ȂĂ|[gԍ
  uint32_t frequency_khz;      //!< I2CNbN̎g P:kHz
  uint8_t  device_address;     //!< p̋@̃AhX
  uint8_t  stop_flag;          //!< ŌSTOP𑗂邩ۂI 0->ȂCȊO->
  uint32_t timeout_threshold;  //!< ̒l𒴂ƃ^CAEgG[ƂȂ P:JEgi[U[ˑj TODO: ɂ邩v
  uint32_t rx_length;          //!< I2CʐMɂMf[^ P: Byte
} I2C_Config;

/**
 * @enum  I2C_ERR_CODE
 * @brief I2Cp̔ėpG[R[h
 * @note  ^int8_tz肵Ă邪, if_listŃbvĂ邽I2ČJ֐̕ԂlintƂȂĂ
 *        {Ȃ̂RX̕Ԃl͐Byte, G[R[hƂȂĂ邽
 */
typedef enum
{
  I2C_UNKNOWN_ERR     = -20,  //!< s
  I2C_RX_BUFFER_SMALL = -14,  //!< Mobt@TCYMf[^菬
  I2C_DATA_NEGA_ERR   = -13,  //!< Mf[^TCỸG[
  I2C_TIMEOUT         = -10,  //!< ʐMTimeout
  I2C_YET_ERR         = -4,   //!< `lI[v
  I2C_ALREADY_ERR     = -3,   //!< `lI[vς
  I2C_FREQUENCY_ERR   = -2,   //!< gُ
  I2C_CH_ERR          = -1,   //!< `lُ (Port_configɖ)
  I2C_OK              = 0,    //!< OK0𓥏P
} I2C_ERR_CODE;

/**
 * @brief I2cConfig\̂O[oCX^XƂĒ`A|C^nƂŃ|[g܂B
 * @param[in] my_i2c_v I2cConfig\̂ւ̃|C^
 * @return int I2C_ERR_CODEƂ, if_listintƓꂳĂB
 * @note I2CʐMbp[̃NXgp鎞͋NɕK{ĂB
 *       ̊֐sOI2cConfig\̓̐ݒlݒ肵ĂKv܂B
 */
int I2C_init(void* my_i2c_v);

/**
 * @brief I2cConfig\̂ɂĎw肳ꂽchf[^M܂
 * @param[in] my_i2c_v    : ΏۂƂI2cConfig\̂ւ̃|C^
 * @param[in] data_v      : Mf[^i[ւ̃|C^
 * @param[in] buffer_size : Mf[^i[̃obt@TCYAI2CʐMɂMf[^Kv
 * @retval 0: Mf[^Ȃ
 * @retval : Mf[^oCg
 * @retval : G[. I2C_ERR_CODE ɏ]
 * @note ̊֐I2Cǂݏov𑗐MĂ܂
 */
int I2C_rx(void* my_i2c_v, void* data_v, int buffer_size);

/**
 * @brief I2cConfig\̂ɂĎw肳ꂽchփf[^𑗐M܂
 * @param[in] my_i2c_v : ΏۂƂI2cConfig\̂ւ̃|C^
 * @param[in] data_v     : Mf[^i[ւ̃|C^
 * @param[in] count      : Mf[^TCY
 * @return int:  I2C_ERR_CODE ɏ]
 */
int I2C_tx(void* my_i2c_v, void* data_v, int data_size);

/**
 * @brief w肳ꂽchJȂ
 * @param[in] my_i2c_v JȂۂ̃|[gݒ
 * @param[in] reason   reopen闝RD0͐푀 TODO: reasonenumH
 * @return int:  I2C_ERR_CODE ɏ]
 */
int I2C_reopen(void* my_i2c_v, int reason);

/**
 * @brief stop_flagݒ肷
 * @param[in] stop_flag ݒ肷stop_flag
 * @return Ȃ
 */
void I2C_set_stop_flag(void* my_i2c_v, const uint8_t stop_flag);

/**
 * @brief rx_lengthݒ肷
 * @param[in] rx_length  ݒ肷Mf[^
 * @return Ȃ
 */
void I2C_set_rx_length(void* my_i2c_v, const uint32_t rx_length);


#endif
