#pragma section REPRO
#include "vector.h"

// C++ɂmathf.h͂Ȃ (math.hɓĂB)
#include <src_user/Settings/sils_define.h>
#ifndef SILS_FW
#include <mathf.h>
#endif
#include <math.h>


// xNgṽmԂ
float VectorNorm(const float* v)
{
  return (float)sqrtf(v[0] * v[0] + v[1] * v[1] + v[2] * v[2]);
}

// xNgv𐳋K̂ansɊi[
int NormalizeVector(const float* v, float* ans)
{
  float norm = VectorNorm(v);
  if (norm < NEGLIGIBLE_VALUE)
  {
    ans[0] = v[0];
    ans[1] = v[1];
    ans[2] = v[2];
    return -1;
  }
  else
  {
    ans[0] = v[0] / norm;
    ans[1] = v[1] / norm;
    ans[2] = v[2] / norm;
    return 0;
  }
}
// xNg̓v1Ev2Ԃ
float VectorInnerProduct(const float* v1, const float* v2)
{
  return v1[0] * v2[0] + v1[1] * v2[1] + v1[2] * v2[2];
}
// xNg̊Ov1~v2ansɊi[
void VectorOuterProduct(const float* v1, const float* v2, float* ans)
{
  ans[0] = v1[1] * v2[2] - v1[2] * v2[1];
  ans[1] = v1[2] * v2[0] - v1[0] * v2[2];
  ans[2] = v1[0] * v2[1] - v1[1] * v2[0];
}
// xNg̃XJ[{a*vansɊi[
void VectorScalarProduct(const float a, const float* v, float* ans)
{
  ans[0] = a * v[0];
  ans[1] = a * v[1];
  ans[2] = a * v[2];
}
// xNg̘av1+v2ansɊi[
void VectorAdd(const float* v1, const float* v2, float* ans)
{
  ans[0] = v1[0] + v2[0];
  ans[1] = v1[1] + v2[1];
  ans[2] = v1[2] + v2[2];
}
// xNg̍v1-v2ansɊi[
void VectorSub(const float* v1, const float* v2, float* ans)
{
  ans[0] = v1[0] - v2[0];
  ans[1] = v1[1] - v2[1];
  ans[2] = v1[2] - v2[2];
}
// xNgv-1{(])ansɊi[
void VectorNeg(const float* v, float* ans)
{
  ans[0] = -v[0];
  ans[1] = -v[1];
  ans[2] = -v[2];
}
// xNgv̒lansɃRs[
void VectorCopy(const float* v, float* ans)
{
  ans[0] = v[0];
  ans[1] = v[1];
  ans[2] = v[2];
}

// 0xNgł1Ԃ
extern char IsZeroVector(const float* v)
{

  if ((fabsf(v[0]) < NEGLIGIBLE_VALUE) && (fabsf(v[1]) < NEGLIGIBLE_VALUE) && (fabsf(v[2]) < NEGLIGIBLE_VALUE))
  {
    return 1;
  }
  return 0;
}

#pragma section
