/**
 * @file mode_manager.h
 * @brief [hJڂ̐̒`
 */
#ifndef MODE_MANAGER_H_
#define MODE_MANAGER_H_

#include "../TimeManager/obc_time.h"
#include <src_user/Settings/Modes/mode_definitions.h>
#include "../../CmdTlm/common_tlm_cmd_packet.h"
#include "../../CmdTlm/block_command_table.h"

#define MM_NOT_DEFINED (BCT_MAX_BLOCKS)

#include <src_user/Settings/Modes/mode_manager_params.h>

/**
 * @enum  MM_ACK
 * @brief ModeManager ֘A֐̕Ԃl
 * @note  uint8_t z
 */
typedef enum
{
  MM_SUCCESS,         //!< 
  MM_BAD_ID,          //!< [hԍُ
  MM_BAD_BC_INDEX,    //!< [hp BC  ID ُ
  MM_INACTIVE_BLOCK,  //!< [hp BC  
  MM_OVERWRITE,       //!< ʂ̃[hJڎs
  MM_ILLEGAL_MOVE,    //!< [hJڗp BC ݂Ȃ
  MM_NOT_IN_PROGRESS, //!< [hJڒł͂Ȃ
  MM_TL_LOAD_FAILED   //!< Task List ւ̃[h BC o^s
} MM_ACK;

/**
 * @enum MM_STATUS
 * @brief [hJڏ
 * @note  uint8_t z
 */
typedef enum
{
  MM_STATUS_FINISHED,   //!< [hJڏI
  MM_STATUS_IN_PROGRESS //!< [hJڎs
} MM_STATUS;

/**
 * @struct MM_TransitionEdge
 * @brief MM TLM p̍\
 * @note TransitionTable Ŝڂ Tlm  1y[WɎ܂Ȃ
 */
typedef struct
{
  uint8_t  from;     //!< [hJڌ
  uint8_t  to;       //!< [hJڐ
  bct_id_t bc_index; //!< [hJڂɊY bc id
} MM_TransitionEdge;

/**
 * @struct ModeManager
 * @brief ModeManager {
 */
typedef struct
{
  bct_id_t mode_list[MD_MODEID_MODE_MAX];                            //!< e[hIDɑΉubNR}hIDۑ
  bct_id_t transition_table[MD_MODEID_MODE_MAX][MD_MODEID_MODE_MAX]; //!< e[hJ(郂[hID炠郂[hIDւ̑J)ɑΉubNR}hۑ
  MM_STATUS stat;                                                    //!< [hJڏ
  MD_MODEID previous_id;                                             //!< ЂƂÕ[hID
  MD_MODEID current_id;                                              //!< ݂̃[hID
  MM_ACK mm_ack;                                                     //!< G[ۑp

  MM_TransitionEdge transition_table_for_tlm[MD_MODEID_MODE_MAX * MD_MODEID_MODE_MAX]; //!< ep̃e[u
} ModeManager;

extern const ModeManager* const mode_manager;

/**
 * @brief [hJڂǗ ModeManager \ (mode_manager_) ̏
 * @param void
 * @return void
 */
void MM_initialize(void);

/**
 * @brief TLM p̐
 * @param void
 * @return uint8_t: J Edge {
 * @note ȅ㕔ŌĂяo悤ɂƃeɏɏ񂪍XVĕ֗ (tlm update cmd łKv)
 */
uint16_t MM_update_transition_table_for_tlm(void);

/**
 * @brief Cmd_MM_SET_MODE_LIST̎
 * @param[in] mode: Ή Mode ID
 * @param[in] bc_index: Mode ɑΉ BC ID
 * @return MM_ACK
 */
MM_ACK MM_set_mode_list(MD_MODEID mode, bct_id_t bc_index);

/**
 * @brief Cmd_MM_SET_TRANSITION_TABLE̎
 * @param[in] from: Jڌ
 * @param[in] to: Jڐ
 * @param[in] bc_index: JڂɑΉ BC ID
 * @return MM_ACK
 */
MM_ACK MM_set_transition_table(MD_MODEID from, MD_MODEID to, bct_id_t bc_index);

/**
 * @brief mode ɑΉ TL  BCT ID 擾
 * @note AT[V͍sȂDs mode ̏ꍇ 0 ԂD
 * @param[in] mode: Ή郂[h
 * @return [hΉ BC ID
 */
bct_id_t MM_get_tasklist_id_of_mode(MD_MODEID mode);

CCP_EXEC_STS Cmd_MM_SET_MODE_LIST(const CTCP* packet);
CCP_EXEC_STS Cmd_MM_SET_TRANSITION_TABLE(const CTCP* packet);
CCP_EXEC_STS Cmd_MM_START_TRANSITION(const CTCP* packet);
CCP_EXEC_STS Cmd_MM_FINISH_TRANSITION(const CTCP* packet);
CCP_EXEC_STS Cmd_MM_UPDATE_TRANSITION_TABLE_FOR_TLM(const CTCP* packet);

#endif
